/*global document, window, console, jQuery, navigator*/
/*jslint maxlen: 150, this:true*/
/*jshint esversion:6, laxbreak:true*/

// Author   : John Sánchez Alvarez
// Creation : 20180511

/*
 * Required
 * jquery-3.1.0.js
 * exists.js
 */

(function ($) {
    "use strict";

    $.extend({
        ValidationRegExp: function () {
            /* Private */
            var this_e,
                endc = "[%END%]";

            function operator_expresion(arg_e) {
                var arg = arg_e || {};

                if (arg.element === "blur") {
                    arg.this_e.val(arg.this_e.val().replace(endc, ""));
                }

                if (arg.reg_1.test(arg.this_e.val())) {
                    arg.this_e.val(arg.this_e.val().replace(arg.reg_1, ""));

                    return arg.this_e.preventD(arg.e);
                }
            }

            function evaluation_expressions(reg_1, ending_e) {
                var reg = reg_1 || false,
                    ending = ending_e || false,
                    array_events = ["keyup"];

                if (reg !== false) {
                    array_events.forEach(function (element) {
                        this_e.on(element, function (e) {
                            if (element === "blur" && ending) {
                                $(this).val($(this).val() + endc);
                            }
                            operator_expresion({
                                reg_1: reg,
                                this_e: $(this),
                                e: e,
                                element: element
                            });
                        });
                    });
                }
            }

            /* Public */
            return {
                version: 20180522,

                start: function (attr_e) {
                    var attr = attr_e || {},
                        fields = attr.fields || undefined;

                    if ($.exists(fields)) {
                        fields.each(function () {
                          this_e = $(this);
                            if ($.exists(typeof $(this).data("format-movil"))
                                || $.exists(typeof $(this).data("format-document"))
                                || $.exists(typeof $(this).data("int-number"))) {
                                evaluation_expressions(/[^\d]/g);
                            }
                        });
                    }
                },

                format_input: function (attr_e) {
                    var attr = attr_e || {},
                        element = attr.element || undefined,
                        eevent = attr.event || undefined,
                        type = attr.type || undefined,
                        regex1,
                        regex2,
                        regex3,
                        subst1,
                        subst2,
                        subst3,
                        get_value;

                    if (element !== undefined) {
                        get_value = element.val();

                        if (eevent.keyCode !== 37
                                && eevent.keyCode !== 39
                                && eevent.keyCode !== 8
                                && eevent.keyCode !== 46) {

                            switch (type) {
                                case "movil":
                                    regex1 = /([0-9]{1,3})/;
                                    regex2 = /([0-9\(\)]{5})([0-9]{1,3})/;
                                    regex3 = /([0-9\(\)\ ]{9})([0-9]{1,4})/;
                                    subst1 = "($1)";
                                    subst2 = "$1 $2";
                                    subst3 = "$1-$2";

                                    if ((parseInt(get_value, 10) / 1000) >= 1) {
                                        get_value = get_value.replace(regex1, subst1);
                                        get_value = get_value.replace(regex2, subst2);
                                        get_value = get_value.replace(regex3, subst3);
                                    }
                                break;
                                case "document":
                                    regex1 = /\B(?=(\d{3})+(?!\d)\.?)/g;
                                    subst1 = ".";

                                    get_value = get_value.replace(regex1, subst1);
                                break;
                            }
                        }

                        return get_value;
                    }
                }
            };
        }
    });
}(jQuery));
