<?php

namespace Drupal\tigo_portability\Controller;

use Drupal\Core\Controller\ControllerBase;

/**
 * Clase para controlar el soporte de tickets.
 *
 * @package Drupal\tigo_portabilidad
 * @license https://transacciones.tigo.com.co/servicios/paquetes  License 3.01
 * @link https://transacciones.tigo.com.co/servicios/paquetes
 */
class ApiTestController extends ControllerBase {

  /**
   * Función que retorna la información al asesor del estado del ticket.
   */
  public function getOrders() {
    $response = '{
    "list": [
        {
            "orderId": "909099999999-01",
            "creationDate": "2019-02-14T16:26:33.0000000+00:00",
            "clientName": "Pruebas ecommerce",
            "items": null,
            "totalValue": 20000,
            "paymentNames": "BANCOLOMBIA",
            "status": "handling",
            "statusDescription": "Preparando Entrega",
            "marketPlaceOrderId": null,
            "sequence": "508000",
            "salesChannel": "1",
            "affiliateId": "",
            "origin": "Marketplace",
            "workflowInErrorState": false,
            "workflowInRetry": false,
            "lastMessageUnread": " Pago Aprobado - Tigo.co --> --> Hola, ecommerce     -->   ¡El pago de tu compra en TigoUNE ha sido aprobado! Muy pronto recibirás el pedido en",
            "ShippingEstimatedDate": "2019-02-18T16:28:08.0000000+00:00",
            "ShippingEstimatedDateMax": null,
            "ShippingEstimatedDateMin": null,
            "orderIsComplete": true,
            "listId": null,
            "listType": null,
            "authorizedDate": "2019-02-14T16:27:52.0000000+00:00",
            "callCenterOperatorName": null,
            "totalItems": 1,
            "currencyCode": "COP"
        }]}';
    print ($response);
    exit;
  }

  /**
   * Función que retorna la información al asesor del estado del ticket.
   */
  public function getOrder() {
    $response = '{
    "orderId": "909099999999-01",
    "sequence": "508000",
    "marketplaceOrderId": "",
    "marketplaceServicesEndpoint": "http://oms.vtexinternal.com.br/api/oms?an=tigocolombia",
    "sellerOrderId": "00-909099999999-01",
    "origin": "Marketplace",
    "affiliateId": "",
    "salesChannel": "1",
    "merchantName": null,
    "status": "handling",
    "statusDescription": "Handling",
    "value": 2000000,
    "creationDate": "2019-01-30T04:54:15.1073421+00:00",
    "lastChange": "2019-01-31T08:55:28.9285008+00:00",
    "orderGroup": "909099999999",
    "totals": [
        {
            "id": "Items",
            "name": "Total de los items",
            "value": 5000000
        },
        {
            "id": "Discounts",
            "name": "Total de descuentos",
            "value": 0
        },
        {
            "id": "Shipping",
            "name": "Costo total del envíado",
            "value": 0
        },
        {
            "id": "Tax",
            "name": "Costo total del cambio",
            "value": 0
        }
    ],
    "items": [
        {
            "uniqueId": "AF6ABBD8F83C45EBB06F4E24F279EE62",
            "id": "4",
            "productId": "3",
            "ean": null,
            "lockId": "00-909099999999-01",
            "itemAttachment": {
                "content": {},
                "name": null
            },
            "attachments": [
                {
                    "name": "Portacion",
                    "content": {
                        "Documento": "192837465",
                        "DonorId": "104",
                        "FechaExpedicion": "2000",
                        "LineaDonante": "3195048307",
                        "NIP": "1234",
                        "TipoDoc": "CC"
                    }
                }
            ],
            "quantity": 1,
            "seller": "1",
            "name": "SIM Prepago + Paquete 5GB - Una línea nueva",
            "refId": "PORTPOS-122",
            "price": 2000000,
            "listPrice": 5000000,
            "manualPrice": null,
            "priceTags": [],
            "imageUrl": "http://tigocolombia.vteximg.com.br/arquivos/ids/156572-210-210/Prepago_5GB.png?v=636782014595530000",
            "detailUrl": "/movil-prepago-paquete-5g/p",
            "components": [],
            "bundleItems": [],
            "params": [],
            "offerings": [],
            "sellerSku": "4",
            "priceValidUntil": null,
            "commission": 0,
            "tax": 0,
            "preSaleDate": null,
            "additionalInfo": {
                "brandName": "Tigo Colombia",
                "brandId": "2000000",
                "categoriesIds": "/1/3/",
                "productClusterId": "152,159",
                "commercialConditionId": "1",
                "dimension": {
                    "cubicweight": 1,
                    "height": 5,
                    "length": 1,
                    "weight": 15,
                    "width": 5
                },
                "offeringInfo": null,
                "offeringType": null,
                "offeringTypeId": null
            },
            "measurementUnit": "un",
            "unitMultiplier": 1,
            "sellingPrice": 5000000,
            "isGift": false,
            "shippingPrice": null,
            "rewardValue": 0,
            "freightCommission": 0,
            "priceDefinitions": null,
            "taxCode": ""
        }
    ],
    "marketplaceItems": [],
    "clientProfileData": {
        "id": "clientProfileData",
        "email": "598247b288b447cc907f4af761e037d4@ct.vtex.com.br",
        "firstName": "Alejandro",
        "lastName": "Osorio",
        "documentType": "cedulaCol",
        "document": "1020718434",
        "phone": "+573015882994",
        "corporateName": null,
        "tradeName": null,
        "corporateDocument": null,
        "stateInscription": null,
        "corporatePhone": null,
        "isCorporate": false,
        "userProfileId": "786a3043-f8f1-407f-9c78-64113761b197",
        "customerClass": null
    },
    "giftRegistryData": null,
    "marketingData": null,
    "ratesAndBenefitsData": {
        "id": "ratesAndBenefitsData",
        "rateAndBenefitsIdentifiers": []
    },
    "shippingData": {
        "id": "shippingData",
        "address": {
            "addressType": "residential",
            "receiverName": "Alejandro Osorio",
            "addressId": "-1548823972999",
            "postalCode": "11001",
            "city": "Bogotá, D.C.",
            "state": "BOGOTÁ, D.C.",
            "country": "COL",
            "street": "Cra 15A #106-15",
            "number": null,
            "neighborhood": "San patricio",
            "complement": "Apto 503",
            "reference": null,
            "geoCoordinates": []
        },
        "logisticsInfo": [
            {
                "itemIndex": 0,
                "selectedSla": "Normal",
                "lockTTL": "12d",
                "price": 0,
                "listPrice": 0,
                "sellingPrice": 0,
                "deliveryWindow": null,
                "deliveryCompany": "Coordinadora",
                "shippingEstimate": "2bd",
                "shippingEstimateDate": null,
                "slas": [
                    {
                        "id": "Normal",
                        "name": "Normal",
                        "shippingEstimate": "2bd",
                        "deliveryWindow": null,
                        "price": 0,
                        "deliveryChannel": "delivery",
                        "pickupStoreInfo": {
                            "additionalInfo": null,
                            "address": null,
                            "dockId": null,
                            "friendlyName": null,
                            "isPickupStore": false
                        },
                        "polygonName": null
                    }
                ],
                "shipsTo": [
                    "COL"
                ],
                "deliveryIds": [
                    {
                        "courierId": "1",
                        "courierName": "Coordinadora",
                        "dockId": "1",
                        "quantity": 1,
                        "warehouseId": "1_1"
                    }
                ],
                "deliveryChannel": "delivery",
                "pickupStoreInfo": {
                    "additionalInfo": null,
                    "address": null,
                    "dockId": null,
                    "friendlyName": null,
                    "isPickupStore": false
                },
                "addressId": "-1548823972999",
                "polygonName": null
            }
        ],
        "trackingHints": null,
        "selectedAddresses": [
            {
                "addressId": "-1548823972999",
                "addressType": "residential",
                "receiverName": "Alejandro Osorio",
                "street": "Cra 15A #106-15",
                "number": null,
                "complement": "Apto 503",
                "neighborhood": "San patricio",
                "postalCode": "11001",
                "city": "BogotÃ¡, D.C.",
                "state": "BOGOTÃ\u0081, D.C.",
                "country": "COL",
                "reference": null,
                "geoCoordinates": []
            }
        ]
    },
    "paymentData": {
        "transactions": [
            {
                "isActive": true,
                "transactionId": "33F90071B20E494FB676936A6E40738B",
                "merchantName": "TIGOCOLOMBIA",
                "payments": [
                    {
                        "id": "3BC4FB7D90EC423DAF6BF08BED4110D9",
                        "paymentSystem": "510035",
                        "paymentSystemName": "BALOTO",
                        "value": 5000000,
                        "installments": 1,
                        "referenceValue": 5000000,
                        "cardHolder": null,
                        "cardNumber": null,
                        "firstDigits": null,
                        "lastDigits": null,
                        "cvv2": null,
                        "expireMonth": null,
                        "expireYear": null,
                        "url": "https://checkout.payulatam.com/ppp-web-gateway-payu/app/v2?vid=212590244Y69b0828108f24e2Y90bd6b20028922b",
                        "giftCardId": null,
                        "giftCardName": null,
                        "giftCardCaption": null,
                        "redemptionCode": null,
                        "group": "bankInvoice",
                        "tid": "69b08281-08f2-4e29-a5a5-573e24237aed",
                        "dueDate": null,
                        "connectorResponses": {
                            "Tid": "69b08281-08f2-4e29-a5a5-573e24237aed",
                            "ReturnCode": "AWAITING_NOTIFICATION",
                            "Message": "La transacciÃ³n estÃ¡ pendiente de ser confirmada",
                            "orderId": "212590244",
                            "state": "PENDING"
                        }
                    }
                ]
            }
        ]
    },
    "packageAttachment": {
        "packages": []
    },
    "sellers": [
        {
            "id": "1",
            "name": "Tigo Colombia",
            "logo": ""
        }
    ],
    "callCenterOperatorData": null,
    "followUpEmail": "0b8dee0eb0e246a7bb0dc56c9f47e295@ct.vtex.com.br",
    "lastMessage": null,
    "hostname": "tigocolombia",
    "invoiceData": null,
    "changesAttachment": null,
    "openTextField": null,
    "roundingError": 0,
    "orderFormId": "bfb00b6e12e24f94be1cd62aed2d4036",
    "commercialConditionData": null,
    "isCompleted": true,
    "customData": null,
    "storePreferencesData": {
        "countryCode": "COL",
        "currencyCode": "COP",
        "currencyFormatInfo": {
            "CurrencyDecimalDigits": 2,
            "CurrencyDecimalSeparator": ",",
            "CurrencyGroupSeparator": ".",
            "CurrencyGroupSize": 3,
            "StartsWithCurrencySymbol": true
        },
        "currencyLocale": 9226,
        "currencySymbol": "$",
        "timeZone": "SA Pacific Standard Time"
    },
    "allowCancellation": false,
    "allowEdition": false,
    "isCheckedIn": false,
    "marketplace": {
        "baseURL": "http://oms.vtexinternal.com.br/api/oms?an=tigocolombia",
        "isCertified": null,
        "name": "tigocolombia"
    },
    "authorizedDate": null,
    "invoicedDate": null
}';
    print ($response);
    exit;
  }

}
