<?php
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
namespace Drupal\tigo_portability\Plugin\rest\resource;

use Drupal\rest\Plugin\ResourceBase;
use Drupal\rest\ModifiedResourceResponse;
use Drupal\rest\ResourceResponse;
use Symfony\Component\HttpFoundation\Request;

/**
 * Provides an Api Portability Resource
 *
 * @RestResource(
 *   id = "api_portability_resource",
 *   label = @Translation("Api portability resource"),
 *   uri_paths = {
 *      "canonical" = "/api/portability/{msisdn}",
 *      "https://www.drupal.org/link-relations/create" = "/api/portability"
 *   }
 * )
 */
class ApiPortability extends ResourceBase
{

    /**
     * Responds to entity GET requests.
     * @return \Drupal\rest\ResourceResponse
     */
    public function get($msisdn)
    {
        $data['msisdn'] = $msisdn;
        $service = \Drupal::service('tigo_portability.operator_donor');
        $service->operator($data);
        $responseWS = $service->getResponse();

        $respuesta = array(
            'payload' => array(
                'donorId' => $responseWS->payload->donorId,
                'name' => $responseWS->payload->name,
                'operatorABD' => $responseWS->payload->operatorABD,
            ),
        );

        $response = ['response' => $respuesta];
        return new ResourceResponse($response);
    }

    /**
     * Responds to POST requests.
     * @return \Drupal\rest\ModifiedResourceResponse
     */
    public function post(Request $request)
    {
        $content = json_decode($request->getContent());
        $data['msisdn'] = $content->msisdn;

        $service = \Drupal::service('tigo_portability.operator_donor');
        $service->operator($data);
        $responseWS = $service->getResponse();
        $donorId = (isset($responseWS->payload->donorId)) ? $responseWS->payload->donorId : null;

        if ($donorId !== NULL) {
            $data['donorid'] = $donorId;
            $service_nip = \Drupal::service('tigo_portability.pin');
            $service_nip->pin($data);
            $response_nip = $service_nip->getResponse();
            $response = array('message' => $response_nip);
            $codeResponse = 501;
        } else {
            $response = array('message' => 'No existe DonorID para el msisdn');
            $codeResponse = 502;
        }

        if ($response_nip === NULL) {
            $response = array('message' => 'Se realizó la solicitud de un NIP de forma exitosa.');
            $codeResponse = 200;
        }

        return new ModifiedResourceResponse($response, $codeResponse);
    }
}
