<?php

namespace Drupal\tigo_portability;

/**
 *
 */
class PortPrepago {

  protected $drupal;
  protected $ticketZendesk;

  /**
   *
   */
  public function __construct($drupal = NULL) {
    $this->drupal = $drupal;
    if (!is_object($this->drupal)) {
      $this->drupal = new \Drupal();
    }
  }

  /**
   *
   */
  public function initPortPrepago($dataPortability) {
    $address = json_decode($dataPortability[0]->address);
    $data = [
      'order_id' => $dataPortability[0]->order_id,
      'item_id' => $dataPortability[0]->item_id,
      'tipo_producto' => $dataPortability[0]->tipo_producto,
      'description' => $dataPortability[0]->description,
      'suscription_id' => $dataPortability[0]->suscription_id,
      'product_id' => $dataPortability[0]->product_id,
      'donorNumber' => $dataPortability[0]->linea_donante,
      'donorId' => $dataPortability[0]->donorid,
      'asesorId' => '1019083585',
      'documentType' => $dataPortability[0]->tipo_documento,
      'documentId' => $dataPortability[0]->documento,
      'anhoExpedicion' => $dataPortability[0]->fecha_expedicion,
      'name' => $dataPortability[0]->client_name,
      'email' => $dataPortability[0]->client_email,
      'NIP' => $dataPortability[0]->nip,
      'imsi' => $dataPortability[0]->imsi,
      'msisdn' => $dataPortability[0]->msisdn,
      'saleType' => 'chip_prepago',
      'address' => $address->street,
      'state' => $address->state,
      'city' => $address->city,
      'telefono' => !is_null($address->number)
      ? $address->number
      : $dataPortability[0]->client_phone,
    ];

    // Llamado Zendesk.
    $this->ticketZendesk = $this->drupal->service('tigo_activation.ticket_tools');
    $returnTicket = $this->ticketZendesk->ticketPortability($data);

    $redirect = FALSE;
    $new_ticket = FALSE;
    if (isset($returnTicket) && is_numeric($returnTicket)) {
      $redirect = TRUE;
      $new_ticket = TRUE;
    }
    $return = [
      'order_id' => $dataPortability[0]->order_id,
      'item_id' => $dataPortability[0]->item_id,
      'new_ticket' => $new_ticket,
      'tipo_producto' => $dataPortability[0]->tipo_producto,
      'tipo_plan' => $dataPortability[0]->tipo_plan,
      'description' => $dataPortability[0]->description,
      'suscription_id' => $dataPortability[0]->suscription_id,
      'ticket' => $returnTicket,
      'tipo_plan' => $dataPortability[0]->tipo_plan,
    ];
    return $return;
  }

}
