<?php
namespace Drupal\tigo_portability\Services;

use Drupal\tigoapi\TigoApi;

/**
 * Class CheckUserTigo
 * @package Drupal\tigo_portability\Services
 */
class CheckUserTigo {

  private $response = null;

  // TigoApi Object for service request's
  protected $api;


  /**
   * {@inheritdoc}
   */
  public function __construct(TigoApi $api) {
    $this->api = $api;
  }

  public function getResponse(){
    return $this->response;
  }

  /**
   * @param $data
   */
  public function check($data) {
    // Build service parameters
    $params = [
        'tokens' => [
            'msisdn' => $data['msisdn']
        ],
        'query' => [
            'searchType' => 'MSISDN',
            'documentType' => 1
        ]
    ];

    // Service consumption
    try {
      $this->response = $this->api->consumption('portability_check_user', $params, TRUE, FALSE);
    }
    catch(\Exception $e) {
      $this->response = $e;
    }
    return $this;
  }
}