<?php
namespace Drupal\tigo_portability\Services;

use Drupal\tigoapi\TigoApi;

/**
 * Class TigoPortability
 * @package Drupal\tigo_portability\Services
 */
class Pin {

  private $response = null;

  // TigoApi Object for service request's
  protected $api;


  /**
   * {@inheritdoc}
   */
  public function __construct(TigoApi $api) {
    $this->api = $api;
  }

  public function getResponse(){
    return $this->response;
  }

  /**
   * @param $data
   */
  public function pin($data) {
    // Build service parameters
    $body = [
        "msisdn" => $data['msisdn'],
        "donorID" => $data['donorid']
    ];
    $params['body'] = json_encode($body);
    $params = [
        'headers' => [
            'Authorization' => 'basic ' . base64_encode('ecommerce:3c0mm3rce.T1g0.2018')
        ],
        'body' => json_encode($body)
    ];

    // Service consumption
    try {
      $this->response = $this->api->consumption('portability_pin', $params, TRUE, FALSE, FALSE);
    }
    catch(\Exception $e) {
      $response = json_decode($e->getMessage());
      $this->response = $response->payload->msgCode . ':' . $response->payload->description . ':' . $response->payload->severity;
      return $this;
    }
    return $this;
  }
}
