<?php
namespace Drupal\tigo_portability\Services;

use Drupal\tigoapi\TigoApi;
use Drupal\tigo_portability\Festivos;

/**
 * Class TigoActivation
 * @package Drupal\tigo_activation\Services
 */
class Portin {

  private $response = null;

  // TigoApi Object for service request's
  protected $api;


  /**
   * {@inheritdoc}
   */
  public function __construct(TigoApi $api) {
    $this->api = $api;
  }

  public function getResponse(){
    return $this->response;
  }

  /**
   * @param $data
   */
  public function port($data) {
    // Build service parameters

    $fecha = date('Y-m-d');
    $count = 0;
    $festivo = new Festivos();
    for ($i = 1; $i <= 3; $i++) {
      $nuevafecha = strtotime('+'.$i.' day', strtotime($fecha));
      if($festivo->festivo(date('Y-m-d', $nuevafecha))){
        $count += 2;
      }else{
        $count += 1;
      }
    }
    $FechaFinal = strtotime('+'.$count.' day', strtotime($fecha));

    $FechaFinal = date('d-m-Y', $FechaFinal);
    
    $body = [
        "msisdn" => $data['msisdn_other'],
        "destinationPlanPrepaid" => 1,//"PLPRE0240", //"PLPRE0238",
        "operatorTransactionID" => time(), //. $data['msisdn_other'],
        "portDate" => $FechaFinal,
        "msisdnTemporary" => $data['msisdn_tigo'],
        "clientInformation" => false,
        "nip" => $data['nip'],
        "subscriberData" => [
            "name" => "",
            "address" => "",
            "document" => [
              "number" => $data['idenfitication_number'],
              "type" => $data['idenfitication_type']
            ]
        ]
    ];
    ksm($body);

    self::queryInsert($data);


    $params = [
        'headers' => [
            'Authorization' => 'basic ' . base64_encode('ecommerce:3c0mm3rce.T1g0.2018')
        ],
        'body' => json_encode($body)
    ];

    // Service consumption
    try {
      $this->response = $this->api->consumption('portability_portin', $params, TRUE, FALSE, FALSE);
    }
    catch(\Exception $e) {
      $this->response = $e;
    }
    return $this;
  }

  /**
   * Insert Log
   */
  public static function queryInsert($data){
    $connection = \Drupal::database();
    $insert = $connection->insert('tigo_portability')
        ->fields(['created', 'msisdn_tigo', 'msisdn_other', 'identification_type', 'identification_number', 'nip'])
        ->values([
            'created' => date('Y-m-d H:i:s'),
            'msisdn_tigo' => $data['msisdn_tigo'],
            'msisdn_other' => $data['msisdn_other'],
            'identification_type' => $data['idenfitication_type'],
            'identification_number' => $data['idenfitication_number'],
            'nip' => $data['nip']
        ])
        ->execute();
  }
}