<?php
namespace Drupal\tigo_portability\Services;

use Drupal\tigoapi\TigoApi;

/**
 * Class TigoPortability
 * @package Drupal\tigo_portability\Services
 */
class Status {

  private $response = null;

  // TigoApi Object for service request's
  protected $api;


  /**
   * {@inheritdoc}
   */
  public function __construct(TigoApi $api) {
    $this->api = $api;
  }

  public function getResponse(){
    return $this->response;
  }

  /**
   * @param $data
   */
  public function status($data) {
    // Build service parameters
    $params = [
        'headers' => [
            'Authorization' => 'basic ' . base64_encode('ecommerce:3c0mm3rce.T1g0.2018')
        ],
        'tokens' => [
            'msisdn' => $data['msisdn']
        ]
    ];

    // Service consumption
    try {
      $this->response = $this->api->consumption('portability_status', $params, TRUE, FALSE, FALSE);
    }
    catch(\Exception $e) {
      $this->response = $e;
    }
    return $this;
  }
}